diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-spectrum-value-helper.cc ns-3.45/src/wifi/model/wifi-spectrum-value-helper.cc
--- ns-3.44/src/wifi/model/wifi-spectrum-value-helper.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-spectrum-value-helper.cc	2025-06-01 20:34:45.631702200 -0700
@@ -489,6 +489,9 @@
     NS_ASSERT_MSG(
         centerFrequencies.size() == 1 || channelWidth == MHz_u{160},
         "PSD for non-contiguous channels is only possible when the total width is 160 MHz");
+    NS_ASSERT_MSG(
+        (channelWidth != 160) || (centerFrequencies.size() <= 2),
+        "It is not possible to create a PSD made of more than 2 segments for a width of 160 MHz");
     NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
                     << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
                     << lowestPoint);
@@ -511,14 +514,6 @@
                       (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     Watt_u txPowerPerBand{0.0};
-    uint32_t start1;
-    uint32_t stop1;
-    uint32_t start2;
-    uint32_t stop2;
-    uint32_t start3;
-    uint32_t stop3;
-    uint32_t start4;
-    uint32_t stop4;
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth =
         static_cast<uint32_t>((MHzToHz(MHz_u{1}) / carrierSpacing) +
@@ -526,6 +521,9 @@
     std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
         centerFrequencies.size()); // list of data/pilot-containing subBands (sent at 0dBr)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
+    std::size_t skippedSubbands{0};
+    std::size_t numAllocatedSubbands{0};
+    std::size_t numDc{0};
     switch (static_cast<uint16_t>(channelWidth))
     {
     case 20:
@@ -533,75 +531,62 @@
         txPowerPerBand = txPower / 242;
         innerSlopeWidth = static_cast<uint32_t>((Hz_u{5e5} / carrierSpacing) +
                                                 0.5); // [-10.25;-9.75] & [9.75;10.25]
-        // skip the guard band and 6 subbands, then place power in 121 subbands, then
-        // skip 3 DC, then place power in 121 subbands, then skip
-        // the final 5 subbands and the guard band.
-        start1 = (nGuardBands / 2) + 6;
-        stop1 = start1 + 121 - 1;
-        start2 = stop1 + 4;
-        stop2 = start2 + 121 - 1;
-        subBandsPerSegment.at(0).emplace_back(start1, stop1);
-        subBandsPerSegment.at(0).emplace_back(start2, stop2);
+        skippedSubbands = 6;
+        numAllocatedSubbands = 121;
+        numDc = 3;
         break;
     case 40:
         // 484 subcarriers (468 data + 16 pilot)
         txPowerPerBand = txPower / 484;
-        // skip the guard band and 12 subbands, then place power in 242 subbands, then
-        // skip 5 DC, then place power in 242 subbands, then skip
-        // the final 11 subbands and the guard band.
-        start1 = (nGuardBands / 2) + 12;
-        stop1 = start1 + 242 - 1;
-        start2 = stop1 + 6;
-        stop2 = start2 + 242 - 1;
-        subBandsPerSegment.at(0).emplace_back(start1, stop1);
-        subBandsPerSegment.at(0).emplace_back(start2, stop2);
+        skippedSubbands = 12;
+        numAllocatedSubbands = 242;
+        numDc = 5;
         break;
     case 80:
-        // 996 subcarriers (980 data + 16 pilot)
-        txPowerPerBand = txPower / 996;
-        // skip the guard band and 12 subbands, then place power in 498 subbands, then
-        // skip 5 DC, then place power in 498 subbands, then skip
-        // the final 11 subbands and the guard band.
-        start1 = (nGuardBands / 2) + 12;
-        stop1 = start1 + 498 - 1;
-        start2 = stop1 + 6;
-        stop2 = start2 + 498 - 1;
-        subBandsPerSegment.at(0).emplace_back(start1, stop1);
-        subBandsPerSegment.at(0).emplace_back(start2, stop2);
-        break;
-    case 160: {
-        NS_ASSERT_MSG(centerFrequencies.size() <= 2,
-                      "It is not possible to create a PSD made of more than 2 segments for a width "
-                      "of 160 MHz");
-        // 2 x 996 subcarriers (2 x 80 MHZ bands)
-        txPowerPerBand = txPower / (2 * 996);
-        start1 = (nGuardBands / 2) + 12;
-        stop1 = start1 + 498 - 1;
-        start2 = stop1 + 6;
-        stop2 = start2 + 498 - 1;
-        start3 = stop2 + (2 * 12) + nUnallocatedBands;
-        stop3 = start3 + 498 - 1;
-        start4 = stop3 + 6;
-        stop4 = start4 + 498 - 1;
-        subBandsPerSegment.at(0).emplace_back(start1, stop1);
-        subBandsPerSegment.at(0).emplace_back(start2, stop2);
-        subBandsPerSegment.at(subBandsPerSegment.size() - 1).emplace_back(start3, stop3);
-        subBandsPerSegment.at(subBandsPerSegment.size() - 1).emplace_back(start4, stop4);
+    case 160: // 2 x 80 MHz
+    case 320: // 4 x 80 MHz
+        // 996 subcarriers (980 data + 16 pilot) per 80 MHz band
+        txPowerPerBand = txPower / (996 * (channelWidth / 80));
+        skippedSubbands = 12;
+        numAllocatedSubbands = 498;
+        numDc = 5;
         break;
-    }
     default:
         NS_FATAL_ERROR("ChannelWidth " << channelWidth << " unsupported");
         break;
     }
 
+    // skip the guard band and skipped subbands, then place power in allocated subbands, then skip
+    // DC subbands, then place power in allocated subbands, then skip the final 11 subbands and the
+    // guard band.
+    auto start = (nGuardBands / 2) + skippedSubbands;
+    auto stop = start + numAllocatedSubbands - 1;
+    subBandsPerSegment.at(0).emplace_back(start, stop);
+    start = stop + numDc + 1;
+    stop = start + numAllocatedSubbands - 1;
+    subBandsPerSegment.at(0).emplace_back(start, stop);
+    if (channelWidth >= 160)
+    {
+        for (std::size_t i = 1; i < (channelWidth / 80); ++i)
+        {
+            start = subBandsPerSegment.front().back().second + (2 * skippedSubbands) +
+                    nUnallocatedBands;
+            auto stop = start + numAllocatedSubbands - 1;
+            subBandsPerSegment.back().emplace_back(start, stop);
+            start = stop + numDc + 1;
+            stop = start + numAllocatedSubbands - 1;
+            subBandsPerSegment.back().emplace_back(start, stop);
+        }
+    }
+
     // Create punctured bands
     auto puncturedSlopeWidth =
         static_cast<uint32_t>((Hz_u{500e3} / carrierSpacing) +
                               0.5); // size in number of subcarriers of the punctured slope band
     std::vector<std::vector<WifiSpectrumBandIndices>> puncturedBandsPerSegment;
     std::size_t subcarriersPerSuband = (MHzToHz(MHz_u{20}) / carrierSpacing);
-    uint32_t start = (nGuardBands / 2);
-    uint32_t stop = start + subcarriersPerSuband - 1;
+    start = (nGuardBands / 2);
+    stop = start + subcarriersPerSuband - 1;
     if (!puncturedSubchannels.empty())
     {
         for (std::size_t i = 0; i < subBandsPerSegment.size(); ++i)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-spectrum-value-helper.h ns-3.45/src/wifi/model/wifi-spectrum-value-helper.h
--- ns-3.44/src/wifi/model/wifi-spectrum-value-helper.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-spectrum-value-helper.h	2025-06-01 20:34:45.631702200 -0700
@@ -125,9 +125,8 @@
         const std::vector<bool>& puncturedSubchannels = {});
 
     /**
-     * Create a transmit power spectral density corresponding to OFDM
-     * High Throughput (HT) (802.11n/ac).  Channel width may vary between
-     * 20, 40, 80, and 160 MHz.
+     * Create a transmit power spectral density corresponding to OFDM High Throughput (HT/VHT)
+     * (802.11n/ac). Channel width may vary between 20, 40, 80, and 160 MHz.
      *
      * @param centerFrequencies center frequency per segment
      * @param channelWidth total allocated channel width over all segments
@@ -149,9 +148,9 @@
         dBr_u lowestPoint = dBr_u{-40});
 
     /**
-     * Create a transmit power spectral density corresponding to OFDM
-     * High Efficiency (HE) (802.11ax) for contiguous channels.
-     * Channel width may vary between 20, 40, 80, and 160 MHz.
+     * Create a transmit power spectral density corresponding to OFDM High Efficiency (HE/EHT)
+     * (802.11ax/be) for contiguous channels. Channel width may vary between 20, 40, 80, 160 and 320
+     * MHz.
      *
      * @param centerFrequency center frequency
      * @param channelWidth channel width
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-tx-vector.cc ns-3.45/src/wifi/model/wifi-tx-vector.cc
--- ns-3.44/src/wifi/model/wifi-tx-vector.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-tx-vector.cc	2025-06-01 20:34:45.632702400 -0700
@@ -75,6 +75,7 @@
       m_triggerResponding(triggerResponding),
       m_modeInitialized(true),
       m_inactiveSubchannels(),
+      m_sigBMcs(EhtPhy::GetVhtMcs(0)),
       m_ruAllocation(),
       m_center26ToneRuIndication(std::nullopt),
       m_ehtPpduType(1) // SU transmission by default
@@ -282,6 +283,9 @@
 {
     NS_ABORT_MSG_IF(!IsMu(), "Not a MU transmission");
     NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU");
+    NS_ASSERT_MSG(m_muUserInfos.empty() || (mode.GetModulationClass() == GetModulationClass()),
+                  "Cannot add mode " << mode << " because the modulation class is "
+                                     << GetModulationClass());
     m_muUserInfos[staId].mcs = mode.GetMcsValue();
     m_modeInitialized = true;
 }
@@ -480,6 +484,17 @@
             }
         }
     }
+    else if (m_channelWidth > 160)
+    {
+        if ((GetModulationClass() < WIFI_MOD_CLASS_EHT) && !IsNonHtDuplicate())
+        {
+            return false;
+        }
+        if ((band == WIFI_PHY_BAND_2_4GHZ) || (band == WIFI_PHY_BAND_5GHZ))
+        {
+            return false;
+        }
+    }
     for (const auto& userInfo : m_muUserInfos)
     {
         if (GetNumStasInRu(userInfo.second.ru) > 8)
@@ -487,7 +502,7 @@
             return false;
         }
     }
-    std::map<HeRu::RuSpec, uint8_t> streamsPerRu{};
+    std::map<WifiRu::RuSpec, uint8_t> streamsPerRu{};
     for (const auto& info : m_muUserInfos)
     {
         auto it = streamsPerRu.find(info.second.ru);
@@ -553,7 +568,7 @@
     {
         return true;
     }
-    std::set<HeRu::RuSpec> rus{};
+    std::set<WifiRu::RuSpec> rus{};
     for (const auto& userInfo : m_muUserInfos)
     {
         rus.insert(userInfo.second.ru);
@@ -585,20 +600,14 @@
 }
 
 uint8_t
-WifiTxVector::GetNumStasInRu(const HeRu::RuSpec& ru) const
+WifiTxVector::GetNumStasInRu(const WifiRu::RuSpec& ru) const
 {
     return std::count_if(m_muUserInfos.cbegin(),
                          m_muUserInfos.cend(),
                          [&ru](const auto& info) -> bool { return (ru == info.second.ru); });
 }
 
-bool
-WifiTxVector::IsAllocated(uint16_t staId) const
-{
-    return m_muUserInfos.contains(staId);
-}
-
-HeRu::RuSpec
+WifiRu::RuSpec
 WifiTxVector::GetRu(uint16_t staId) const
 {
     NS_ABORT_MSG_IF(!IsMu(), "RU only available for MU");
@@ -607,7 +616,7 @@
 }
 
 void
-WifiTxVector::SetRu(HeRu::RuSpec ru, uint16_t staId)
+WifiTxVector::SetRu(WifiRu::RuSpec ru, uint16_t staId)
 {
     NS_ABORT_MSG_IF(!IsMu(), "RU only available for MU");
     NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU");
@@ -649,7 +658,13 @@
 bool
 WifiTxVector::IsSigBCompression() const
 {
-    return IsDlMuMimo() && !IsDlOfdma();
+    // SIG-B compression is used in case of full-bandwidth MU-MIMO transmission (27.3.11.8.2
+    // HE-SIG-B content channels in IEEE802.11ax-2021) or if a single RU occupies the whole 160 MHz
+    // bandwidth (27.3.11.8.3 Common field in IEEE802.11ax-2021)
+    return (IsDlMuMimo() && !IsDlOfdma()) ||
+           ((m_muUserInfos.size() == 1) && (m_channelWidth >= MHz_u{160}) &&
+            (WifiRu::GetRuType(m_muUserInfos.cbegin()->second.ru) ==
+             WifiRu::GetRuType(m_channelWidth)));
 }
 
 void
@@ -676,6 +691,7 @@
 void
 WifiTxVector::SetCenter26ToneRuIndication(Center26ToneRuIndication center26ToneRuIndication)
 {
+    NS_ASSERT(GetModulationClass() == WIFI_MOD_CLASS_HE);
     if (IsDlMu())
     {
         NS_ASSERT(center26ToneRuIndication == DeriveCenter26ToneRuIndication());
@@ -686,7 +702,7 @@
 std::optional<Center26ToneRuIndication>
 WifiTxVector::GetCenter26ToneRuIndication() const
 {
-    if (!IsDlMu() || (m_channelWidth < MHz_u{80}))
+    if ((GetModulationClass() != WIFI_MOD_CLASS_HE) || !IsDlMu() || (m_channelWidth < MHz_u{80}))
     {
         return std::nullopt;
     }
@@ -766,7 +782,7 @@
 WifiTxVector::UserInfoMapOrderedByRus
 WifiTxVector::GetUserInfoMapOrderedByRus(uint8_t p20Index) const
 {
-    auto heRuComparator = HeRu::RuSpecCompare(m_channelWidth, p20Index);
+    auto heRuComparator = WifiRu::RuSpecCompare(m_channelWidth, p20Index);
     UserInfoMapOrderedByRus orderedMap{heRuComparator};
     for (const auto& userInfo : m_muUserInfos)
     {
@@ -777,7 +793,7 @@
         }
         else
         {
-            orderedMap.emplace(userInfo.second.ru, std::set<uint16_t>{userInfo.first});
+            orderedMap.emplace(ru, std::set<uint16_t>{userInfo.first});
         }
     }
     return orderedMap;
@@ -786,64 +802,83 @@
 RuAllocation
 WifiTxVector::DeriveRuAllocation(uint8_t p20Index) const
 {
-    RuAllocation ruAllocations(Count20MHzSubchannels(m_channelWidth), HeRu::EMPTY_242_TONE_RU);
-    std::vector<HeRu::RuType> ruTypes{};
+    const auto mc = GetModulationClass();
+    const auto emptyRu =
+        (mc == WIFI_MOD_CLASS_HE) ? EMPTY_242_TONE_HE_RU : UNASSIGNED_242_TONE_EHT_RU;
+    RuAllocation ruAllocations(Count20MHzSubchannels(m_channelWidth), emptyRu);
+    std::vector<RuType> ruTypes{};
     ruTypes.resize(ruAllocations.size());
     const auto& orderedMap = GetUserInfoMapOrderedByRus(p20Index);
+    std::pair<std::size_t /* number of RUs in content channel 1 */,
+              std::size_t /* number of RUs in content channel 2 */>
+        ccSizes{0, 0};
     for (const auto& [ru, staIds] : orderedMap)
     {
-        const auto ruType = ru.GetRuType();
-        const auto ruBw = HeRu::GetBandwidth(ruType);
-        const auto isPrimary80MHz = ru.GetPrimary80MHz();
-        const auto rusPerSubchannel =
-            HeRu::GetRusOfType(ruBw > MHz_u{20} ? ruBw : MHz_u{20}, ruType);
-        auto ruIndex = ru.GetIndex();
-        if ((m_channelWidth >= MHz_u{80}) && (ruIndex > 19))
+        const auto ruType = WifiRu::GetRuType(ru);
+        auto ruIndex = WifiRu::GetPhyIndex(ru, m_channelWidth, p20Index);
+        if ((ruType == RuType::RU_26_TONE) && (ruIndex == 19))
         {
-            // take into account the center 26-tone RU in the primary 80 MHz
-            ruIndex--;
+            continue;
         }
-        if ((!isPrimary80MHz) && (ruIndex > 19))
+        const auto ruBw = WifiRu::GetBandwidth(ruType);
+        const auto rusPerSubchannel =
+            WifiRu::GetRusOfType(ruBw > MHz_u{20} ? ruBw : MHz_u{20}, ruType, mc);
+        if ((m_channelWidth >= MHz_u{80}) && (ruIndex > 19))
         {
-            // take into account the center 26-tone RU in the secondary 80 MHz
+            // "ignore" the center 26-tone RUs in 80 MHz channels
             ruIndex--;
-        }
-        if (!isPrimary80MHz && (ruType != HeRu::RU_2x996_TONE))
-        {
-            NS_ASSERT(m_channelWidth > MHz_u{80});
-            // adjust RU index for the secondary 80 MHz: in that case index is restarting at 1,
-            // hence we need to add an offset corresponding to the number of RUs of the same type in
-            // the primary 80 MHz
-            ruIndex += HeRu::GetRusOfType(MHz_u{80}, ruType).size();
+            if (ruIndex > 37)
+            {
+                ruIndex -= (ruIndex - 19) / 37;
+            }
         }
         const auto numSubchannelsForRu = (ruBw < MHz_u{20}) ? 1 : Count20MHzSubchannels(ruBw);
         const auto index = (ruBw < MHz_u{20}) ? ((ruIndex - 1) / rusPerSubchannel.size())
                                               : ((ruIndex - 1) * numSubchannelsForRu);
         NS_ABORT_IF(index >= Count20MHzSubchannels(m_channelWidth));
-        auto ruAlloc = HeRu::GetEqualizedRuAllocation(ruType, false);
-        if (ruAllocations.at(index) != HeRu::EMPTY_242_TONE_RU)
+        auto ruAlloc = WifiRu::GetEqualizedRuAllocation(ruType, false, true, mc);
+        if (ruAllocations.at(index) != emptyRu)
         {
             if (ruType == ruTypes.at(index))
             {
                 continue;
             }
-            if (ruType == HeRu::RU_26_TONE)
+            if (ruType == RuType::RU_26_TONE)
             {
-                ruAlloc = HeRu::GetEqualizedRuAllocation(ruTypes.at(index), true);
+                ruAlloc = WifiRu::GetEqualizedRuAllocation(ruTypes.at(index), true, true, mc);
             }
-            else if (ruTypes.at(index) == HeRu::RU_26_TONE)
+            else if (ruTypes.at(index) == RuType::RU_26_TONE)
             {
-                ruAlloc = HeRu::GetEqualizedRuAllocation(ruType, true);
+                ruAlloc = WifiRu::GetEqualizedRuAllocation(ruType, true, true, mc);
             }
             else
             {
                 NS_ASSERT_MSG(false, "unsupported RU combination");
             }
         }
+        std::size_t ccIndex;
+        if (ruType >= RuType::RU_484_TONE)
+        {
+            ccIndex = (ccSizes.first <= ccSizes.second) ? 0 : 1;
+        }
+        else
+        {
+            ccIndex = (index % 2 == 0) ? 0 : 1;
+        }
+        if (ccIndex == 0)
+        {
+            ccSizes.first += staIds.size();
+        }
+        else
+        {
+            ccSizes.second += staIds.size();
+        }
         for (std::size_t i = 0; i < numSubchannelsForRu; ++i)
         {
+            auto ruAllocNoUsers = WifiRu::GetEqualizedRuAllocation(ruType, false, false, mc);
             ruTypes.at(index + i) = ruType;
-            ruAllocations.at(index + i) = ruAlloc;
+            ruAllocations.at(index + i) =
+                (IsSigBCompression() || ((index + i) % 2) == ccIndex) ? ruAlloc : ruAllocNoUsers;
         }
     }
     return ruAllocations;
@@ -855,12 +890,14 @@
     uint8_t center26ToneRuIndication{0};
     for (const auto& userInfo : m_muUserInfos)
     {
-        if ((userInfo.second.ru.GetRuType() == HeRu::RU_26_TONE) &&
-            (userInfo.second.ru.GetIndex() == 19))
-        {
-            center26ToneRuIndication |= (userInfo.second.ru.GetPrimary80MHz())
-                                            ? CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED
-                                            : CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED;
+        NS_ASSERT(WifiRu::IsHe(userInfo.second.ru));
+        if ((WifiRu::GetRuType(userInfo.second.ru) == RuType::RU_26_TONE) &&
+            (WifiRu::GetIndex(userInfo.second.ru) == 19))
+        {
+            center26ToneRuIndication |=
+                (std::get<HeRu::RuSpec>(userInfo.second.ru).GetPrimary80MHz())
+                    ? CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED
+                    : CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED;
         }
     }
     return static_cast<Center26ToneRuIndication>(center26ToneRuIndication);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-tx-vector.h ns-3.45/src/wifi/model/wifi-tx-vector.h
--- ns-3.44/src/wifi/model/wifi-tx-vector.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-tx-vector.h	2025-06-01 20:34:45.632702400 -0700
@@ -13,8 +13,8 @@
 #include "wifi-mode.h"
 #include "wifi-phy-band.h"
 #include "wifi-phy-common.h"
+#include "wifi-ru.h"
 
-#include "ns3/he-ru.h"
 #include "ns3/nstime.h"
 
 #include <list>
@@ -25,15 +25,12 @@
 namespace ns3
 {
 
-/// STA_ID for a RU that is intended for no user (Section 26.11.1 802.11ax-2021)
-static constexpr uint16_t NO_USER_STA_ID = 2046;
-
 /// HE MU specific user transmission parameters.
 struct HeMuUserInfo
 {
-    HeRu::RuSpec ru; ///< RU specification
-    uint8_t mcs;     ///< MCS index
-    uint8_t nss;     ///< number of spatial streams
+    WifiRu::RuSpec ru; ///< RU specification
+    uint8_t mcs;       ///< MCS index
+    uint8_t nss;       ///< number of spatial streams
 
     /**
      * Compare this user info to the given user info.
@@ -381,19 +378,13 @@
      */
     bool IsDlMuMimo() const;
     /**
-     * Check if STA ID is allocated
-     * @param staId STA ID
-     * @return true if allocated, false otherwise
-     */
-    bool IsAllocated(uint16_t staId) const;
-    /**
      * Get the RU specification for the STA-ID.
      * This is applicable only for MU.
      *
      * @param staId the station ID
      * @return the RU specification for the STA-ID
      */
-    HeRu::RuSpec GetRu(uint16_t staId) const;
+    WifiRu::RuSpec GetRu(uint16_t staId) const;
     /**
      * Set the RU specification for the STA-ID.
      * This is applicable only for MU.
@@ -401,7 +392,7 @@
      * @param ru the RU specification
      * @param staId the station ID
      */
-    void SetRu(HeRu::RuSpec ru, uint16_t staId);
+    void SetRu(WifiRu::RuSpec ru, uint16_t staId);
     /**
      * Get the HE MU user-specific transmission information for the given STA-ID.
      * This is applicable only for HE MU.
@@ -434,7 +425,8 @@
     HeMuUserInfoMap& GetHeMuUserInfoMap();
 
     /// map of specific user info parameters ordered per increasing frequency RUs
-    using UserInfoMapOrderedByRus = std::map<HeRu::RuSpec, std::set<uint16_t>, HeRu::RuSpecCompare>;
+    using UserInfoMapOrderedByRus =
+        std::map<WifiRu::RuSpec, std::set<uint16_t>, WifiRu::RuSpecCompare>;
 
     /**
      * Get the map of specific user info parameters ordered per increasing frequency RUs.
@@ -546,7 +538,7 @@
      * @param ru the RU specification
      * @return the number of STAs in the RU
      */
-    uint8_t GetNumStasInRu(const HeRu::RuSpec& ru) const;
+    uint8_t GetNumStasInRu(const WifiRu::RuSpec& ru) const;
 
     WifiMode m_mode;          /**< The DATARATE parameter in Table 15-4.
                               It is the value that will be passed
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-types.h ns-3.45/src/wifi/model/wifi-types.h
--- ns-3.44/src/wifi/model/wifi-types.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-types.h	2025-06-01 20:34:45.632702400 -0700
@@ -11,6 +11,12 @@
 
 #include "wifi-units.h"
 
+#include "ns3/fatal-error.h"
+
+#include <compare>
+#include <map>
+#include <ostream>
+
 namespace ns3
 {
 
@@ -29,6 +35,7 @@
     CW_80MHZ,
     CW_160MHZ,
     CW_80_PLUS_80MHZ,
+    CW_320MHZ,
     CW_2160MHZ,
     MAX,
 };
@@ -85,6 +92,76 @@
     CH_80211P
 };
 
+/**
+ * The different Resource Unit (RU) types.
+ */
+enum class RuType : uint8_t
+{
+    RU_26_TONE = 0,
+    RU_52_TONE,
+    RU_106_TONE,
+    RU_242_TONE,
+    RU_484_TONE,
+    RU_996_TONE,
+    RU_2x996_TONE,
+    RU_4x996_TONE,
+    RU_TYPE_MAX
+};
+
+/**
+ * @brief Stream insertion operator.
+ *
+ * @param os the stream
+ * @param ruType the RU type
+ * @returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, const RuType& ruType)
+{
+    switch (ruType)
+    {
+    case RuType::RU_26_TONE:
+        os << "26-tones";
+        break;
+    case RuType::RU_52_TONE:
+        os << "52-tones";
+        break;
+    case RuType::RU_106_TONE:
+        os << "106-tones";
+        break;
+    case RuType::RU_242_TONE:
+        os << "242-tones";
+        break;
+    case RuType::RU_484_TONE:
+        os << "484-tones";
+        break;
+    case RuType::RU_996_TONE:
+        os << "996-tones";
+        break;
+    case RuType::RU_2x996_TONE:
+        os << "2x996-tones";
+        break;
+    case RuType::RU_4x996_TONE:
+        os << "4x996-tones";
+        break;
+    default:
+        NS_FATAL_ERROR("Unknown RU type");
+    }
+    return os;
+}
+
+/// (lowest index, highest index) pair defining a subcarrier range
+using SubcarrierRange = std::pair<int16_t, int16_t>;
+
+/// a vector of subcarrier ranges defining a subcarrier group
+using SubcarrierGroup = std::vector<SubcarrierRange>;
+
+/// (bandwidth, number of tones) pair
+using BwTonesPair = std::pair<MHz_u, RuType>;
+
+/// map (bandwidth, number of tones) pairs to the group of subcarrier ranges
+using SubcarrierGroups = std::map<BwTonesPair, std::vector<SubcarrierGroup>>;
+
 } // namespace ns3
 
 #endif /* WIFI_TYPES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-utils.cc ns-3.45/src/wifi/model/wifi-utils.cc
--- ns-3.44/src/wifi/model/wifi-utils.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-utils.cc	2025-06-01 20:34:45.632702400 -0700
@@ -13,6 +13,7 @@
 #include "gcr-manager.h"
 #include "wifi-mac-header.h"
 #include "wifi-mac-trailer.h"
+#include "wifi-tx-vector.h"
 
 #include "ns3/packet.h"
 
@@ -21,8 +22,6 @@
 namespace ns3
 {
 
-const Time WIFI_TU = MicroSeconds(WIFI_TU_US);
-
 double
 DbToRatio(dB_u val)
 {
@@ -77,12 +76,14 @@
 }
 
 uint32_t
-GetMuBarSize(std::list<BlockAckReqType> types)
+GetMuBarSize(TriggerFrameVariant variant, MHz_u bw, const std::list<BlockAckReqType>& types)
 {
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_TRIGGER);
     CtrlTriggerHeader trigger;
     trigger.SetType(TriggerFrameType::MU_BAR_TRIGGER);
+    trigger.SetVariant(variant);
+    trigger.SetUlBandwidth(bw);
     for (auto& t : types)
     {
         auto userInfo = trigger.AddUserInfoField();
@@ -109,6 +110,61 @@
     return size;
 }
 
+Time
+GetEstimatedAckTxTime(const WifiTxVector& txVector)
+{
+    auto modClass = txVector.GetModulationClass();
+
+    switch (modClass)
+    {
+    case WIFI_MOD_CLASS_DSSS:
+    case WIFI_MOD_CLASS_HR_DSSS:
+        if (txVector.GetMode().GetDataRate(txVector) == 1e6)
+        {
+            return MicroSeconds(304);
+        }
+        else if (txVector.GetPreambleType() == WIFI_PREAMBLE_LONG)
+        {
+            return MicroSeconds(248);
+        }
+        else
+        {
+            return MicroSeconds(152);
+        }
+        break;
+    case WIFI_MOD_CLASS_ERP_OFDM:
+    case WIFI_MOD_CLASS_OFDM:
+        if (auto constSize = txVector.GetMode().GetConstellationSize(); constSize == 2)
+        {
+            return MicroSeconds(44);
+        }
+        else if (constSize == 4)
+        {
+            return MicroSeconds(32);
+        }
+        else
+        {
+            return MicroSeconds(28);
+        }
+        break;
+    default: {
+        auto staId = (txVector.IsMu() ? txVector.GetHeMuUserInfoMap().begin()->first : SU_STA_ID);
+        if (const auto constSize = txVector.GetMode(staId).GetConstellationSize(); constSize == 2)
+        {
+            return MicroSeconds(68);
+        }
+        else if (constSize == 4)
+        {
+            return MicroSeconds(44);
+        }
+        else
+        {
+            return MicroSeconds(32);
+        }
+    }
+    }
+}
+
 bool
 IsInWindow(uint16_t seq, uint16_t winstart, uint16_t winsize)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-utils.h ns-3.45/src/wifi/model/wifi-utils.h
--- ns-3.44/src/wifi/model/wifi-utils.h	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/model/wifi-utils.h	2025-06-01 20:34:45.632702400 -0700
@@ -10,10 +10,10 @@
 #define WIFI_UTILS_H
 
 #include "block-ack-type.h"
+#include "wifi-constants.h"
 #include "wifi-types.h"
 
 #include "ns3/fatal-error.h"
-#include "ns3/nstime.h"
 #include "ns3/ptr.h"
 
 #include <list>
@@ -27,6 +27,9 @@
 class WifiMacHeader;
 class Packet;
 class WifiMac;
+class WifiTxVector;
+
+enum class TriggerFrameVariant : uint8_t;
 
 /**
  * Wifi direction. Values are those defined for the TID-to-Link Mapping Control Direction
@@ -179,10 +182,14 @@
 /**
  * Return the total MU-BAR size (including FCS trailer).
  *
+ * @param variant the Common Info field variant of the MU-BAR
+ * @param bw the bandwidth over which the MU-BAR is transmitted
  * @param types the list of Block Ack Request types of the individual BARs
  * @return the total MU-BAR size in bytes
  */
-uint32_t GetMuBarSize(std::list<BlockAckReqType> types);
+uint32_t GetMuBarSize(TriggerFrameVariant variant,
+                      MHz_u bw,
+                      const std::list<BlockAckReqType>& types);
 /**
  * Return the total RTS size (including FCS trailer).
  *
@@ -195,6 +202,13 @@
  * @return the total CTS size in bytes
  */
 uint32_t GetCtsSize();
+
+/**
+ * @param txVector the TXVECTOR used to transmit a frame whose reception failed
+ * @return the estimated Ack TX time, based on Table 10-8 of IEEE 802.11REVme D7.0
+ */
+Time GetEstimatedAckTxTime(const WifiTxVector& txVector);
+
 /**
  * @param seq MPDU sequence number
  * @param winstart sequence number window start
@@ -261,12 +275,6 @@
  */
 Mac48Address GetIndividuallyAddressedRecipient(Ptr<WifiMac> mac, const WifiMacHeader& hdr);
 
-/// Size of the space of sequence numbers
-static constexpr uint16_t SEQNO_SPACE_SIZE = 4096;
-
-/// Size of the half the space of sequence numbers (used to determine old packets)
-static constexpr uint16_t SEQNO_SPACE_HALF_SIZE = SEQNO_SPACE_SIZE / 2;
-
 /// Link ID for single link operations (helps tracking places where correct link
 /// ID is to be used to support multi-link operations)
 static constexpr uint8_t SINGLE_LINK_OP_ID = 0;
@@ -277,13 +285,6 @@
 /// Invalid TID identifier
 static constexpr uint8_t WIFI_TID_UNDEFINED = 0xff;
 
-/// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
-/// Used to initialize WIFI_TU
-constexpr int WIFI_TU_US = 1024;
-
-/// Wi-Fi Time Unit (see IEEE 802.11-2020 sec. 3.1)
-extern const Time WIFI_TU;
-
 } // namespace ns3
 
 #endif /* WIFI_UTILS_H */
